#include "gt5688.h"
#include "touch.h"
#include "ctiic.h"
#include "usart.h"
#include "delay.h" 
#include "string.h" 
#include "lcd.h" 
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK STM32F407
//5.0ݴ-GT5688 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2014/5/7
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2014-2024
//All rights reserved									  
////////////////////////////////////////////////////////////////////////////////// 

//GT5688

#if 1

//xֵ0x0320=800
//yֵ0x01E0=480
//0x43=67
//0x8050~0x813B  236Ĵ
//0x813C  0x813DУ
//0x813E  ø±
const u8 GT5688_CFG_TBL[]=
{ 
	0x42,0x20,0x03,0xE0,0x01,0x05,0x3D,0x10,0x01,0x00,
	0x08,0x08,0x50,0x3C,0x53,0x11,0x00,0x00,0x00,0x00,
	0x14,0x14,0x14,0x22,0x08,0x04,0x00,0x00,0x00,0x00,
	0x3C,0x00,0x53,0x00,0x14,0x00,0x00,0x84,0x00,0x00,
	0x00,0x00,0x00,0x64,0x1E,0x1E,0x8A,0x2A,0x0C,0x3C,
	0x3E,0xF4,0x0A,0x20,0x33,0x60,0x12,0x02,0x24,0x00,
	0x00,0x32,0x64,0x00,0x14,0x02,0x00,0x00,0x54,0x80,
	0x35,0x7F,0x3D,0x7F,0x46,0x7F,0x51,0x7F,0x5D,0x7F,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x50,0x3C,
	0xBB,0xBB,0x07,0x00,0x00,0x00,0x02,0x0F,0x14,0x03,
	0x04,0x10,0x42,0xF8,0x0F,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x32,0x20,0x50,0x3C,0x3C,0x00,0x00,0x00,0x00,0x00,
	0x0D,0x06,0x0C,0x05,0x0B,0x04,0x0A,0x03,0x09,0x02,
	0x08,0x01,0xFF,0xFF,0x00,0x01,0x02,0x03,0x04,0x05,
	0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x3C,0x00,0x05,0x1E,0x00,0x02,
	0x2A,0x1E,0x19,0x14,0x02,0x00,0x03,0x0A,0x05,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x04,
	0x22,0x03,0x00,0x00,0x33,0x00,0x14,0x00,0x00,0x28,
	0x46,0x32,0x50,0x00,0x00,0x00,0xF9,0xBD,0x01,
};  
#endif




u16 CRC16(u8 *srcdata,u16 length)
{
	u16 crc=0xffff;
	u16 i,j;
	u8 value;
	for(i=0;i<length;i++)
	{
		for(j=0;j<8;j++)
		{
			value=((srcdata[i]<<j)&0x80)^((crc&0x8000)>>8);	
			crc<<=1;
			if(value!=0)
			{
				crc^=0x8005;
			}
		}
	}
	return crc;
}

//GT5688ò
//mode:0,浽flash
//     1,浽flash
u8 GT5688_Send_Cfg(u8 mode)
{

	u16 checksum=0;
	//u8 buf[3];
	u8 i=0;	
	for(i=0;i<(sizeof(GT5688_CFG_TBL)-3);i+=2)
		checksum +=((GT5688_CFG_TBL[i]<<8)|GT5688_CFG_TBL[i+1]);//У
		//checksum +=(GT5688_CFG_TBL[i]<<8)+GT5688_CFG_TBL[i+1];
	//checksum =0-checksum;
	 checksum =(~checksum)+1;
	printf("chksum:0x%x,\r\n",checksum);
	//buf[0]= checksum>>8;
	//buf[1]= checksum;
	//buf[2]= mode;	//Ƿд뵽GT5688 FLASH?  Ƿ籣
	//GT5688_WR_Reg(GT_CFGS_REG,(u8*)GT5688_CFG_TBL,sizeof(GT5688_CFG_TBL));//ͼĴ
	return 0;

} 

//GT5688дһ
//reg:ʼĴַ
//buf:ݻ
//len:дݳ
//ֵ:0,ɹ;1,ʧ.
u8 GT5688_WR_Reg(u16 reg,u8 *buf,u8 len)
{
	u8 i;
	u8 ret=0;
	CT_IIC_Start();	
 	CT_IIC_Send_Byte(GT_CMD_WR);   	//д 	  0x28
	CT_IIC_Wait_Ack();
	CT_IIC_Send_Byte(reg>>8);   	//͸8λַ
	CT_IIC_Wait_Ack(); 	 										  		   
	CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
	CT_IIC_Wait_Ack();  
	for(i=0;i<len;i++)
	{	   
    	CT_IIC_Send_Byte(buf[i]);  	//
		ret=CT_IIC_Wait_Ack();
		if(ret)break;  
	}
    CT_IIC_Stop();					//һֹͣ	    
	return ret; 
}
//GT5688һ
//reg:ʼĴַ
//buf:ݻ
//len:ݳ			  
void GT5688_RD_Reg(u16 reg,u8 *buf,u8 len)
{
	u8 i; 
 	CT_IIC_Start();	
 	CT_IIC_Send_Byte(GT_CMD_WR);   //д 	0x28 
	CT_IIC_Wait_Ack();
 	CT_IIC_Send_Byte(reg>>8);   	  //͸8λַ
	CT_IIC_Wait_Ack(); 	 										  		   
 	CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
	CT_IIC_Wait_Ack();  
 	CT_IIC_Start();  	 	   
	CT_IIC_Send_Byte(GT_CMD_RD);   //Ͷ	0x29
	CT_IIC_Wait_Ack();	   
	for(i=0;i<len;i++)
	{	   
    	buf[i]=CT_IIC_Read_Byte(i==(len-1)?0:1); //	  
	} 
    CT_IIC_Stop();//һֹͣ    
} 
//ʼGT5688
//ֵ:0,ʼɹ;1,ʼʧ 
u8 GT5688_Init(void)
{
	u8 temp[5]; 
    u8 temp1[1];
    u8 temp2[1];
	GPIO_InitTypeDef  GPIO_InitStructure;	
	
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB|RCC_AHB1Periph_GPIOC, ENABLE);//ʹGPIOB,Cʱ

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1 ;//PB1Ϊ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;//ģʽ
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;//100MHz
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ
		
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;//PC13Ϊ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
	GPIO_Init(GPIOC, &GPIO_InitStructure);//ʼ	
	
	CT_IIC_Init();      	//ʼI2C  
	GT_RST=0;				//λ
	delay_ms(10);
 	GT_RST=1;				//ͷŸλ		    
	delay_ms(10); 
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;//PB1Ϊ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ	
	
	delay_ms(100);  
	GT5688_RD_Reg(GT_PID_REG,temp,4);//ȡƷID
	temp[4]=0;
	printf("CTP ID:%s\r\n",temp);	//ӡID
	if(strcmp((char*)temp,"5688")==0)//ID==9147
	{
		temp[0]=0X02;			
		GT5688_WR_Reg(GT_CTRL_REG,temp,1);//λGT5668
		GT5688_RD_Reg(GT_CFGS_REG,temp,1);//ȡGT_CFGS_REGĴ
//		if(temp[0]<0X60)//Ĭϰ汾Ƚϵ,Ҫflash
		{
			printf("Default Ver:%d\r\n",temp[0]);
            printf("Default Ver:0x%x\r\n",temp[0]);
			//GT5688_Send_Cfg(1);//²
            
            GT5688_RD_Reg(0x813C,temp1,1);
            printf("0x813C:0x%x\r\n",temp1[0]);
            GT5688_RD_Reg(0x813D,temp2,1);
            printf("0x813D:0x%x\r\n",temp2[0]);
            
		}
		delay_ms(10);
		temp[0]=0X00;	 
		GT5688_WR_Reg(GT_CTRL_REG,temp,1);//λ   
		return 0;
	} 
	return 1;
}
const u16 GT5688_TPX_TBL[5]={GT_TP1_REG,GT_TP2_REG,GT_TP3_REG,GT_TP4_REG,GT_TP5_REG};
//ɨ败(òѯʽ)
//mode:0,ɨ.
//ֵ:ǰ״̬.
//0,޴;1,д
u8 GT5688_Scan(u8 mode)
{
	u8 buf[4];
	u8 i=0;
	u8 res=0;
	u8 temp;
	u8 tempsta;
 	static u8 t=0;//Ʋѯ,ӶCPUռ   
	t++;
	if((t%10)==0||t<10)//ʱ,ÿ10CTP_Scanż1,ӶʡCPUʹ
	{
		GT5688_RD_Reg(GT_GSTID_REG,&mode,1);	//ȡ״̬  
 		if(mode&0X80&&((mode&0XF)<6))
		{
			temp=0;
			GT5688_WR_Reg(GT_GSTID_REG,&temp,1);//־ 		
		}		
		if((mode&0XF)&&((mode&0XF)<6))
		{
			temp=0XFF<<(mode&0XF);		//ĸתΪ1λ,ƥtp_dev.sta 
			tempsta=tp_dev.sta;			//浱ǰtp_dev.staֵ
			tp_dev.sta=(~temp)|TP_PRES_DOWN|TP_CATH_PRES; 
			tp_dev.x[4]=tp_dev.x[0];	//津0
			tp_dev.y[4]=tp_dev.y[0];
			for(i=0;i<5;i++)
			{
				if(tp_dev.sta&(1<<i))	//Ч?
				{
					GT5688_RD_Reg(GT5688_TPX_TBL[i],buf,4);	//ȡXYֵ
					if(tp_dev.touchtype&0X01)//
					{
						/*
						tp_dev.y[i]=((u16)buf[1]<<8)+buf[0];
						tp_dev.x[i]=800-(((u16)buf[3]<<8)+buf[2]);
						*/
						
						tp_dev.x[i]=(((u16)buf[1]<<8)+buf[0]);
						tp_dev.y[i]=(((u16)buf[3]<<8)+buf[2]);
						
					}else
					{
						
						tp_dev.x[i]=((u16)buf[1]<<8)+buf[0];
						tp_dev.y[i]=((u16)buf[3]<<8)+buf[2];
						
					}  
					printf("x[%d]:%d,y[%d]:%d\r\n",i,tp_dev.x[i],i,tp_dev.y[i]);
				}			
			} 
			res=1;
			if(tp_dev.x[0]>lcddev.width||tp_dev.y[0]>lcddev.height)//Ƿ(곬)
			{ 
				if((mode&0XF)>1)		//,򸴵ڶݵһ.
				{
					tp_dev.x[0]=tp_dev.x[1];
					tp_dev.y[0]=tp_dev.y[1];
					t=0;				//һ,10,Ӷ
				}else					//Ƿ,Դ˴(ԭԭ)  
				{
					tp_dev.x[0]=tp_dev.x[4];
					tp_dev.y[0]=tp_dev.y[4];
					mode=0X80;		
					tp_dev.sta=tempsta;	//ָtp_dev.sta
				}
			}else t=0;					//һ,10,Ӷ
		}
	}
	if((mode&0X8F)==0X80)//޴㰴
	{ 
		if(tp_dev.sta&TP_PRES_DOWN)	//֮ǰǱµ
		{
			tp_dev.sta&=~(1<<7);	//ǰɿ
		}else						//֮ǰûб
		{ 
			tp_dev.x[0]=0xffff;
			tp_dev.y[0]=0xffff;
			tp_dev.sta&=0XE0;	//Ч	
		}	 
	} 	
	if(t>240)t=10;//´10ʼ
	return res;
}
 

